-- ------------------------------------------------------------------------------ --
--                                TradeSkillMaster                                --
--                          https://tradeskillmaster.com                          --
--    All Rights Reserved - Detailed license information included with addon.     --
-- ------------------------------------------------------------------------------ --

local TSM = select(2, ...) ---@type TSM
local Sniper = TSM.Operations:NewPackage("Sniper")
local Operation = TSM.LibTSMTypes:Include("Operation")
local Group = TSM.LibTSMTypes:Include("Group")
local CustomString = TSM.LibTSMTypes:Include("CustomString")
local L = TSM.Include("Locale").GetTable()
local CustomPrice = TSM.Include("Service.CustomPrice")
local private = {}



-- ============================================================================
-- Module Functions
-- ============================================================================

function Sniper.OnInitialize()
	local operationType = Operation.NewType("Sniper", L["Sniper"], 1)
		:SetDescriptionFunc(private.GetDescription)
		:AddStringSetting("belowPrice", "max(vendorsell, ifgt(DBRegionMarketAvg, 250000g, 0.8, ifgt(DBRegionMarketAvg, 100000g, 0.7, ifgt(DBRegionMarketAvg, 50000g, 0.6, ifgt(DBRegionMarketAvg, 25000g, 0.5, ifgt(DBRegionMarketAvg, 10000g, 0.4, ifgt(DBRegionMarketAvg, 5000g, 0.3, ifgt(DBRegionMarketAvg, 2000g, 0.2, ifgt(DBRegionMarketAvg, 1000g, 0.1, 0.05)))))))) * DBRegionMarketAvg)")
	TSM.Operations.RegisterType(operationType)
end

function Sniper.IsOperationValid(itemString)
	local _, operationSettings = TSM.Operations.GetFirstOperationByItem("Sniper", itemString)
	if not operationSettings then
		return false
	end
	local isValid = CustomPrice.Validate(operationSettings.belowPrice)
	return isValid
end

function Sniper.HasOperation(itemString)
	itemString = Group.TranslateItemString(itemString)
	return TSM.Operations.GetFirstOperationByItem("Sniper", itemString) and true or false
end

function Sniper.GetBelowPrice(itemString)
	itemString = Group.TranslateItemString(itemString)
	local operationName, operationSettings = TSM.Operations.GetFirstOperationByItem("Sniper", itemString)
	if not operationName then
		return
	end
	local value = CustomString.GetValue(operationSettings.belowPrice, itemString)
	return value
end



-- ============================================================================
-- Private Helper Functions
-- ============================================================================

function private.GetDescription(operationSettings)
	return L["Sniping items below a max price"]
end
